using UnityEngine;
using System.Collections;

[RequireComponent(typeof(AudioSource))]
public class End : MonoBehaviour {

    public GUISkin skin2D;
    public GUISkin menuSkin;

   public AudioClip looseClip;
   public AudioClip winClip;

    bool soundOn = false;
    string playSound = "correct";


    void OnGUI() {
        GUI.skin = skin2D;
        GUI.backgroundColor = Color.white;
        GUI.color = Color.white;

        //adjust for screen size
        GUI.skin.label.fontSize = 32;
        GUI.Box(new Rect(0, 0, Screen.width, GUI.skin.label.fontSize + 6), "");
        GUI.Box(new Rect(0, Screen.height - 14, Screen.width, 14), "");
        //left label: heading
        GUI.Label(new Rect(Screen.width * 0.5f - 250, 2, 500, GUI.skin.label.fontSize + 2), "Cubecatcher Endscreen");

        GUI.skin = menuSkin;
        GUI.skin.label.fontSize = 24;
        string outroText = "";
        if (globalVars.levelWon) {
            outroText = "CONGRATULATIONS, YOU WON!\n Your level score: " + globalVars.levelScore + "\nYour total score: " + globalVars.totalScore + "\n\nYou collected " + globalVars.correctCubes + " cubes correctly \n" + globalVars.wrongCubes + " cubes incorrectly \nand " + globalVars.potatoCount + " potatoes\n in " + globalVars.playTime + " seconds.\n\n\nPress Enter to Continue on a more difficult level.\n\nPress Escape to return to the main menu.";
        }  else if (globalVars.levelLost) {
            outroText = "Oh, it looks like you lost.\n Hopefully this was just bad luck. Try again. Your score: " + globalVars.levelScore + "\nYour total score: " + globalVars.totalScore + "\n\n You collected " + globalVars.correctCubes + " cubes correctly \n" + globalVars.wrongCubes + " cubes incorrectly \nand " + globalVars.potatoCount + " potatoes \n\n in " + globalVars.countDownTime + " seconds.\n\n\nPress Enter to retry.\n\nPress Escape to return to the main menu.";
        }

        GUI.Label(new Rect(50, 100, Screen.width - 100, 500), outroText);

    }


    void Start(){

        if (globalVars.levelWon){
            soundOn = true;
            playSound = "loose";
        } else if (globalVars.levelLost){
           soundOn = true;
            playSound = "win";
        }
}


    void Update() {
        if (Input.GetKeyDown("return") || Input.GetKeyDown("space")) {
            globalVars.levelDifficulty++;
            Application.LoadLevel("Game");
        }
        if (Input.GetKeyDown("escape")) {
            Application.LoadLevel("Start");
        }

        StartAudio();

      
    }

    void StartAudio() {
        if (soundOn == true) {
             if (playSound == "loose") {
                audio.clip = looseClip;
            } else if (playSound == "win") {
                audio.clip = winClip;
            }
            audio.Play();
          //  yield return new WaitForSeconds(audio.clip.length);
            soundOn = false;
        }
    }

}



