using UnityEngine;
using System.Collections;

public class globalVars : MonoBehaviour {

    public static float versionNumber = 1.1f;
    public static int levelDifficulty = 1;  //level difficulty, equals level number, increases with each replay

    public static int playerScore = 0;    //the player's score from collecting cubes + potatoes
    public static bool levelWon = false;    // was the level won
    public static bool levelLost = false;   // was the level lost
    public static int targetScore = 50;     //score that needs to be reached to win a level
    public static int levelScore;           //final level score multiplied with remaining playtime
    public static int totalScore;           //score over multiple won levels
    public static Color activeColor;        //the active target color, changed randomly every x seconds
    public static bool cubeActive = false;   //can cubes be picked up, safety trigger to prevent weird stuff from happening
    public static int activeCubes = 0;      //numberof cubes that are currently in scene
    public static int correctCubes = 0;     //number of cubes that were collected at the right time (when cube color = active color)
    public static int wrongCubes = 0;       //number of cubes that were collected at the wrong time
    public static int correctInRow = 0;     //series of correct collections in a row, coudl be used for power ups later on
    public static int potatoCount = 0;      //number of potatoes collected
    public static int potatoesSpawned = 0;  //how many potatoes were spawned at all.
    public static int potatoChance = 20;    //chance of potato spawning (i.e. 20 = 1 in 20)

    public static int blueActive = 0;      //count active blue cubes
    public static int greenActive = 0;     //count active green cubes
    public static int yellowActive = 0;    //count active yellow cubes 

    //used in randomColor function in cubeBehaviour.cs
    public static bool spawnYellow = false;   //changes newly spawned cubes to this color 
    public static bool spawnGreen = false;    //if there are none of that color in the scene
    public static bool spawnBlue = false;   //not a great solution but it works
    public static bool colorBalance = true;  //color mix activation to balance active cube colors for startup

    public static float countdown;     //the countdown timer
    bool countdownRun = false;         //is the countdown active
    public static int countDownTime = 60;  //how long is the countdown; changes wit each level
    public static float playTime = 0;      //how long did the player play
     
    float colSwitchTime = 5.0f;            //how fast is the active color switched
    bool colWarnActive = false;        //is the color warning active

    public static Color yellow = Color.yellow;
    public static Color green = Color.green;
    public static Color blue = new Color(0, 0.5f, 1, 1);

    public Transform cube1;

	// Use this for initialization
	void Start () {
        resetAll();
        setLevelDifficulty();
        playerScore = 0;
        //randomColor();
        InvokeRepeating("randomColor", 0, colSwitchTime); //invoke 5 seconds after first invoke and then every 5 seconds
        colorMix();    
        StartCountdown(countDownTime);
	}

	// Update is called once per frame
	void Update () {
        colorMix();     
        // StartCoroutine(cubeCollectTimer(0.1f));
        if (countdown <= 0) {
        //    print("Out of time, game over!");
            levelLost = true;
            levelScore = Mathf.CeilToInt(playerScore * countdown);
            Application.LoadLevel("End");
        }
        if (playerScore >= targetScore) {
            levelScore = Mathf.CeilToInt(playerScore * countdown);
            totalScore += levelScore;
            playTime = countDownTime - countdown;
            countdownRun = false;

         //   print("Success! Level completed! ");
            levelWon = true;
            Application.LoadLevel("End");

        }

        if (Input.GetKeyDown("escape")) {
           Application.LoadLevel("Start");
        }
        Countdown();
	}


    IEnumerator cubeCollectTimer(float t) {
        if(cubeActive){
            print("pickup disabled");
            yield return new WaitForSeconds(t);
            cubeActive = false;
        }
    }



    void randomColor() {         
            int colorSwitch = Mathf.FloorToInt(Random.Range(1, 4));
            Color oldCol = activeColor;    
            Color newCol = Color.white;
            if (colorSwitch == 1)   {
                newCol = yellow;
            } else if(colorSwitch == 2) {
                newCol = green;
            } else if(colorSwitch == 3) {
                newCol = blue; //blue
            }

            colWarnActive = true;
            StartCoroutine(colWarning(0.05f, oldCol, newCol));
    }

    //lets the currenctly active color and the next color blink 3 times as a warning
    IEnumerator colWarning (float t, Color oC, Color nC) {
        if(colWarnActive) {
           // print("color warning");
            activeColor = oC;
            yield return new WaitForSeconds(t);
            activeColor = nC;
            yield return new WaitForSeconds(t);
            activeColor = oC;
            yield return new WaitForSeconds(t);
            activeColor = nC;
            yield return new WaitForSeconds(t);
            activeColor = oC;
            yield return new WaitForSeconds(t);
            activeColor = nC;
            colWarnActive = false;
        }
    }


    //countdown functions
    void StartCountdown(float time) {
        countdownRun = true;
        countdown = time;
    }
    void Countdown() {
        if (countdownRun) {
            countdown -= Time.deltaTime;
            //  print(countdown);
            if (countdown <= 0) {
                //Do your stuff
                countdownRun = false;
            }
        }
    }
    //checks if at least one cube of the active color is in the scene
    void colorMix () {
        if(activeColor == yellow && yellowActive == 0) {
            print("yelloooo");
            spawnYellow = true;
            placeRandomly(1, 1, cube1);
        }
        if(activeColor == green && greenActive == 0) {
            print("greeeeen");
            spawnGreen = true;
            placeRandomly(1, 1, cube1);
        }
        if(activeColor == blue && blueActive == 0) {
            print("bluuuueee");
            spawnBlue = true;
            placeRandomly(1, 1, cube1);
        }
        
    }

     //sets the difficulties for the levels
    void setLevelDifficulty() {

        if (levelDifficulty == 1) {
            countDownTime = 60;
            targetScore = 50;
        } else if (levelDifficulty == 2) {
            countDownTime = 60;
            targetScore = 100;
        } else if (levelDifficulty == 3) {
            countDownTime = 45;
            targetScore = 125;
        } else  if (levelDifficulty == 4) {
            countDownTime = 30;
            targetScore = 150;
            colSwitchTime = 4.0f;
        } else if (levelDifficulty == 5) {
            countDownTime = 30;
            targetScore = 200;
            colSwitchTime = 4.0f;
        } else {
            countDownTime = 60;
            targetScore = 500;
            colSwitchTime = 3.0f;
        }
    }


    void resetAll(){
        playerScore = 0;
        targetScore  = 50;
        levelScore = 0;
        cubeActive = false;
        activeCubes = 0;
        countdownRun = false;
        countDownTime = 60;
        potatoCount = 0;
        potatoesSpawned = 0;
        correctCubes = 0;
        wrongCubes = 0;
        correctInRow = 0;
        potatoChance = 10;
        levelWon = false;
        levelLost = false;
        playTime = 0;
        colSwitchTime = 5.0f;
    }



    //spreads a number of cubes within a predifined target area, size modifier needed to esnure potatoes are always bigger
    void placeRandomly (int number, int sizeMod, Transform objectType) {

        int i = 0;

        float a = Screen.width;
        float b = Screen.height;
        float ratio = a / b;


        int xMin = Mathf.FloorToInt(-Camera.main.orthographicSize * ratio);
        int xMax = Mathf.FloorToInt(Camera.main.orthographicSize * ratio);
        int zMin = Mathf.FloorToInt(-Camera.main.orthographicSize + 1);
        int zMax = Mathf.FloorToInt(Camera.main.orthographicSize - 1);


        while(i < number) {
            int x = Random.Range(xMin, xMax);
            int z = Random.Range(zMin, zMax);
            int y = 0;
            Transform objectInstance = Instantiate(objectType, new Vector3(x, y, z), Quaternion.identity) as Transform;
            int randSize = Mathf.FloorToInt(Random.Range(1, 5) * sizeMod);
            objectInstance.transform.localScale = new Vector3(randSize, randSize, randSize);
            i++;
        }

        //print("cubes deployed");
    }

}
